package GCG.Clients.Extended;

import GCG.protokoll.PROTOKOLL;
import abiturklassen.netz.Client;

/**
 * Ein CLient, der die Meldungen des Servers an einen Ausgabeframe unbearbeitet
 * weiterleitet.
 * 
 * @version 5.0 vom 20.12.2015
 * @author Klaus Bovermann
 */
public class ExtendedGraphClient extends Client {

	private ExtendedGraphClientFrame meineGUI;

	/**
	 * Ein neuer Client wird erzeugt, der mit einem Server (IP / Port)
	 * kommuniziert und eine graphische Benutzeroberflaeche zur Kommunikation
	 * benutzt.
	 * 
	 * @param pIPAdresse
	 * @param pPortNr
	 * @param pDieGUI
	 */
	public ExtendedGraphClient(String pIPAdresse, int pPortNr, ExtendedGraphClientFrame pDieGUI) {
		super(pIPAdresse, pPortNr);
		this.meineGUI = pDieGUI;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see abiturklassen.netz.Client#processMessage(java.lang.String)
	 */
	public void processMessage(String pMessage) {
		String[] tags = pMessage.split(PROTOKOLL.TRENNER);
		this.meineGUI.messageVerarbeiten(pMessage);
		if (tags[0].equals(PROTOKOLL.SC_GEWINN_ENDE)) {
			this.close();
		}
	}
}
