package GCG.Clients.Extended;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.border.EmptyBorder;

import GCG.protokoll.PROTOKOLL;

import javax.swing.JLabel;
import java.awt.Dimension;

/**
 * @version 5.0 vom 20.12.2015
 * @author Klaus Bovermann
 */
@SuppressWarnings("serial")
public class ExtendedGraphClientFrame extends JFrame {

	private JPanel contentPane;
	private JTextField ipEingabeFeld;
	private JTextField portEingabeFeld;

	private JButton btnVerbinden;

	private JTextArea ausgabeTextArea;
	private JScrollPane ausgabeScrollPane;
	private JPanel southPanel;
	private JTextField sendungEingabeFeld;
	private JButton btnNachrichtSchicken;

	private ExtendedGraphClient meinClient;
	private ExtendedGraphClientPane derGraphPane;

	private JLabel lblAnzahlFarben;
	private JButton btnAktiv;
	private JPanel southNorthPanel;
	private JPanel southSouthPanel;
	private JLabel lblFehlermeldung;

	/**
	 * Create the frame.
	 */
	public ExtendedGraphClientFrame() {
		
		setResizable(false);
		setTitle("GraphColoringGame");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 800, 600);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		contentPane.setLayout(new BorderLayout(0, 0));
		setContentPane(contentPane);

		JPanel northPanel = new JPanel();
		contentPane.add(northPanel, BorderLayout.NORTH);

		ipEingabeFeld = new JTextField();
		ipEingabeFeld.setText("localhost");
		northPanel.add(ipEingabeFeld);
		ipEingabeFeld.setColumns(10);

		portEingabeFeld = new JTextField();
		portEingabeFeld.setText("55555");
		northPanel.add(portEingabeFeld);
		portEingabeFeld.setColumns(10);

		btnVerbinden = new JButton("verbinden");
		btnVerbinden.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				verbinden();
			}
		});
		northPanel.add(btnVerbinden);

		ausgabeTextArea = new JTextArea();
		ausgabeTextArea.setPreferredSize(new Dimension(130, 20));
		ausgabeTextArea.setText("Weitere Meldungen");

		ausgabeScrollPane = new JScrollPane(ausgabeTextArea);
		ausgabeScrollPane.setPreferredSize(new Dimension(150, 50));
		contentPane.add(ausgabeScrollPane, BorderLayout.EAST);

		southPanel = new JPanel();
		contentPane.add(southPanel, BorderLayout.SOUTH);
		southPanel.setLayout(new BorderLayout(0, 0));

		southNorthPanel = new JPanel();
		southPanel.add(southNorthPanel, BorderLayout.NORTH);

		sendungEingabeFeld = new JTextField();
		southNorthPanel.add(sendungEingabeFeld);
		sendungEingabeFeld.setText("F:A:1");
		sendungEingabeFeld.setColumns(10);

		btnNachrichtSchicken = new JButton("--> Server");
		southNorthPanel.add(btnNachrichtSchicken);
		btnNachrichtSchicken.setEnabled(false);

		southSouthPanel = new JPanel();
		southPanel.add(southSouthPanel, BorderLayout.SOUTH);

		btnAktiv = new JButton("Nicht aktiv!");
		southSouthPanel.add(btnAktiv);
		btnAktiv.setEnabled(false);

		lblAnzahlFarben = new JLabel("Bisher keine Farbinfos!");
		southSouthPanel.add(lblAnzahlFarben);

		lblFehlermeldung = new JLabel("");
		southPanel.add(lblFehlermeldung, BorderLayout.CENTER);
		btnNachrichtSchicken.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				senden();
			}
		});
	}

	/**
	 * @param pMessage
	 */
	public synchronized void messageVerarbeiten(String pMessage) {
		String[] teile = pMessage.split(PROTOKOLL.TRENNER);
		this.lblFehlermeldung.setText("Fehler: --");

		switch (teile[0]) {
		case PROTOKOLL.SC_OK:
			if (teile.length == 2) {
				this.meldungAusgeben(teile[1]);
			} else {
				this.meldungAusgeben("Alles OK");
			}
			break;
		case PROTOKOLL.SC_GRAPH:
			if (teile.length == 2) {
//				while (derGraphPane == null) {
//					System.out.println("XX: warten!!!");
//				}
//				System.out.println("XX: fertig!!!");

				if (!this.derGraphPane.isVisible()) {
					this.derGraphPane.setVisible(true);
				}
				this.derGraphPane.GraphAnzeigen(teile[1]);
			} else {
				this.lblFehlermeldung.setText("Fehler: " + "Syntaxfehler SC_GRAPH");
			}
			break;
		case PROTOKOLL.SC_FARBZAHL:
			if (teile.length == 2) {
				this.lblAnzahlFarben.setText("Es gibt " + teile[1] + " Farben.");
				this.derGraphPane.setAnzahlFarben(Integer.parseInt(teile[1]));
			} else {
				this.lblFehlermeldung.setText("Fehler: " + "Farbanzahl beim Server unbekannt!");
			}
			break;
		case PROTOKOLL.SC_GEFAERBT:
			if (teile.length == 3) {
				this.derGraphPane.updateColor(teile[1], teile[2]);
			} else {
				this.lblFehlermeldung.setText("Fehler: " + "Syntaxfehler SC_GEFAERBT");
			}
			break;
		case PROTOKOLL.SC_ERROR:
			if (teile.length == 2) {
				this.lblFehlermeldung.setText("Fehler: " + teile[1]);
			} else {
				this.lblFehlermeldung.setText("allgemeiner Fehler!");
			}
			break;
		case PROTOKOLL.SC_NAME:
			if (teile.length == 2) {
				this.setTitle("GraphColoringGame: " + teile[1]);
			} else {
				this.lblFehlermeldung.setText("Fehler: " + "Name vom Server nicht geschickt!");
			}
			break;
		case PROTOKOLL.SC_AKTIV:
			this.btnAktiv.setText("Aktiv!");
			break;
		case PROTOKOLL.SC_INAKTIV:
			this.btnAktiv.setText("Nicht Aktiv!");
			break;
		case PROTOKOLL.SC_START:
			this.btnNachrichtSchicken.setEnabled(true);
			break;
		case PROTOKOLL.SC_GEWINN_ENDE:
			if (teile.length == 2) {
				this.lblFehlermeldung.setText("Gewonnen hat Spieler " + teile[1]);
			} else {
				this.lblFehlermeldung.setText("Gewinner ohne Angabe");
			}
			break;
		case PROTOKOLL.SC_UNENTSCHIEDEN:
			this.lblFehlermeldung.setText("Das Spiel endet unentschieden!");
			break;
		default:
			meldungAusgeben(pMessage); // Was kann das noch sein???
		}
	}

	private void meldungAusgeben(String message) {
		String bisher = this.ausgabeTextArea.getText();
		bisher = message + "\n" + bisher;
		this.ausgabeTextArea.setText(bisher);
	}

	private synchronized void verbinden() {
		if (this.btnVerbinden.isEnabled()) {
			String serverIP = this.ipEingabeFeld.getText();
			int serverPort = Integer.valueOf(this.portEingabeFeld.getText());
			this.meinClient = new ExtendedGraphClient(serverIP, serverPort, this);
			this.derGraphPane = new ExtendedGraphClientPane(this.meinClient);
			contentPane.add(derGraphPane, BorderLayout.CENTER);

			this.btnVerbinden.setEnabled(false);
		}
	}

	private void senden() {
		if (this.btnNachrichtSchicken.isEnabled()) {
			String message = this.sendungEingabeFeld.getText();
			this.meinClient.send(message);
		}
	}
}
