package GCG.Clients.Simple;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.border.EmptyBorder;

/**
 * @version 5.0 vom 20.12.2015
 * @author Klaus Bovermann
 */
@SuppressWarnings("serial")
public class SimpleGraphClientFrame extends JFrame {

	private JPanel contentPane;
	private JTextField ipEingabeFeld;
	private JTextField portEingabeFeld;

	private JButton btnVerbinden;

	private JTextArea ausgabeTextArea;
	private JScrollPane ausgabeScrollPane;
	private JPanel southPanel;
	private JTextField sendungEingabeFeld;
	private JButton btnNachrichtSchicken;

	private SimpleGraphClient meinClient;

	/**
	 * Create the frame.
	 */
	public SimpleGraphClientFrame() {
		setTitle("GraphColoringGame");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 450, 300);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		contentPane.setLayout(new BorderLayout(0, 0));
		setContentPane(contentPane);

		JPanel northPanel = new JPanel();
		contentPane.add(northPanel, BorderLayout.NORTH);

		ipEingabeFeld = new JTextField();
		ipEingabeFeld.setText("localhost");
		northPanel.add(ipEingabeFeld);
		ipEingabeFeld.setColumns(10);

		portEingabeFeld = new JTextField();
		portEingabeFeld.setText("55555");
		northPanel.add(portEingabeFeld);
		portEingabeFeld.setColumns(10);

		btnVerbinden = new JButton("verbinden");
		btnVerbinden.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				verbinden();
			}
		});
		northPanel.add(btnVerbinden);

		ausgabeTextArea = new JTextArea();

		ausgabeScrollPane = new JScrollPane(ausgabeTextArea);
		contentPane.add(ausgabeScrollPane, BorderLayout.CENTER);

		southPanel = new JPanel();
		contentPane.add(southPanel, BorderLayout.SOUTH);

		sendungEingabeFeld = new JTextField();
		sendungEingabeFeld.setText("F:A:1");
		southPanel.add(sendungEingabeFeld);
		sendungEingabeFeld.setColumns(10);

		btnNachrichtSchicken = new JButton("--> Server");
		btnNachrichtSchicken.setEnabled(false);
		btnNachrichtSchicken.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				senden();
			}
		});
		southPanel.add(btnNachrichtSchicken);
	}

	public void ausgeben(String message) {
		String bisher = this.ausgabeTextArea.getText();
		bisher = message + "\n" + bisher;
		this.ausgabeTextArea.setText(bisher);
	}

	private void verbinden() {
		if (this.btnVerbinden.isEnabled()) {
			String serverIP = this.ipEingabeFeld.getText();
			int serverPort = Integer.valueOf(this.portEingabeFeld.getText());
			this.meinClient = new SimpleGraphClient(serverIP, serverPort, this);
			this.btnVerbinden.setEnabled(false);
			this.btnNachrichtSchicken.setEnabled(true);
		}
	}

	private void senden() {
		if (this.btnNachrichtSchicken.isEnabled()) {
			String message = this.sendungEingabeFeld.getText();
			this.meinClient.send(message);
		}
	}
}
