package GCG.protokoll;

/**
 * Diese Zeichenketten werden zwischen Client und Server ausgetauscht.
 * 
 * @version 4.1 vom 19.11.2015
 * @author Klaus Bovermann
 */
public class PROTOKOLL {

	// ------------------------------------------------------------------------

	/**
	 * (F) mit Trenner wird der Knotenname und, durch KOMMA getrennt, die
	 * Farbnummer angehaengt.
	 * 
	 * Meldung an den Server: Ich faerbe den Knoten xxx mit der Farbe fff
	 */
	public static final String CS_FAERBE = "F";

	/**
	 * (K) Anfrage an den Server: gib mir die Knoteninfos
	 */
	public static final String CS_KNOTEN = "K";

	/**
	 * (G) Anfrage an den Server: gib mir die Grapheninfos
	 */
	public static final String CS_GRAPH = "G";

	/**
	 * (A) Anfrage an den Server: wie viele Farben sind zulaessig?
	 */
	public static final String CS_FARBZAHL = "A";

	// ------------------------------------------------------------------------

	/**
	 * (O) mit Trenner werden Meldungen anhehaengt
	 */
	public static final String SC_OK = "O";

	/**
	 * (F) Mit Trenner wird der Knotenname und, mit KOMMA getrennt, die
	 * Farbnummer angehaengt.
	 * 
	 * Der Knoten mit dem angegebenen Namen wurde mit der Farbe (angegebene
	 * Nummer) gefaerbt.
	 */
	public static final String SC_GEFAERBT = "F";

	/**
	 * (K) Mit Trenner wird der Knotenstring angehaengt
	 */
	public static final String SC_KNOTEN = "K";

	/**
	 * (N) Mit Trenner wird der Name des Spielers angehaengt
	 */
	public static final String SC_NAME = "N";

	/**
	 * (G) Mit Trenner wird der Graphstring angehaengt
	 */
	public static final String SC_GRAPH = "G";

	/**
	 * (A) Mit Trenner wird die Anzahl der zulaessigen Farben angehaengt
	 */
	public static final String SC_FARBZAHL = "A";

	/**
	 * (E) mit Trenner wird die Fehlermeldung anhehaengt
	 */
	public static final String SC_ERROR = "E";

	/**
	 * (U) Das Spiel wurde unentschieden beendet.
	 */
	public static final String SC_UNENTSCHIEDEN = "U";

	/**
	 * (B) Das Spiel ist beendet. Mit Trenner wird der Name des Siegers angehaengt.
	 */
	public static final String SC_GEWINN_ENDE = "B";

	/**
	 * (V) Die Kommunikation mit dem anfragenden Clienten wurde beendet. Es
	 * wird noch eine Nachricht per Trenner angehaengt.
	 */
	public static final String SC_VERBINDUNG_BEENDET = "V";

	/**
	 * (S) Das Spiel wird gestartet.
	 */
	public static final String SC_START = "S";

	/**
	 * (Z) Sie sind jetzt am Zug.
	 */
	public static final String SC_AKTIV = "Z";

	/**
	 * (X) Sie sind jetzt am nicht Zug.
	 */
	public static final String SC_INAKTIV = "X";

	// ------------------------------------------------------------------------

	/**
	 * (:) Nachrichten werden immer in der Form TAG TRENNER INFOS verschickt.
	 */
	public static final String TRENNER = ":";

	// ------------------------------------------------------------------------
}
