package GCG.server;

import abiturklassen.linear.Queue;

/**
 * 
 * @version Testversion 0.2; noch nicht benutzt! vom 21.11.2015
 * @author Klaus Bovermann
 *
 */
public class Spielergruppe {

	private int limit;
	private Queue<EinSpieler> dieGruppe;
	private int anzahlAngemeldeterSpieler;

	private boolean gestartet;

	/**
	 * @return the anzahlAngemeldeterSpieler
	 */
	public int getAnzahlAngemeldeterSpieler() {
		return anzahlAngemeldeterSpieler;
	}

	public Spielergruppe(int limit) {
		this.dieGruppe = new Queue<>();
		this.gestartet = false;
		this.limit = limit;
		this.anzahlAngemeldeterSpieler = 0;
	}

	/**
	 * @return the erster
	 */
	public EinSpieler getErster() {
		if (this.dieGruppe.isEmpty()) {
			return null;
		} else {
			return this.dieGruppe.front();
		}
	}

	public boolean isActiv(String ip, int port) {
		EinSpieler erster = this.dieGruppe.front();
		if (erster != null && this.istSpielGestartet()) {
			return erster.getIp().equals(ip) && erster.getPort() == port;
		} else {
			return false;
		}
	}

	public void next() {
		EinSpieler erster = this.getErster();
		this.dieGruppe.dequeue();
		this.dieGruppe.enqueue(erster);
	}

	/**
	 * Das Spiel startet; der erste Spieler darf beginnen.
	 */
	public void start() {
		if (!gestartet && this.anzahlAngemeldeterSpieler == limit) {
			// this.getErster().setAktiv(true);
			// this.getZweiter().setAktiv(false);
			this.gestartet = true;
		}
	}

	public boolean hinzu(String ip, int port) {
		if (this.istSpielGestartet()) {
			return false;
		} else if (this.anzahlAngemeldeterSpieler > this.limit) {
			return false;
		} else {
			EinSpieler neuer = new EinSpieler(ip, port);
			neuer.setName("" + (this.anzahlAngemeldeterSpieler + 1) + ". Spieler");
			this.dieGruppe.enqueue(neuer);
			this.anzahlAngemeldeterSpieler++;
			return true;
		}
	}

	public boolean istSpielGestartet() {
		return this.gestartet;
	}
}
