package GCG.oldClient;

import GCG.protokoll.PROTOKOLL;
import abiturklassen.netz.Client;

/**
 * Ein CLient, der die Meldungen des Servers an einen Ausgabeframe unbearbeitet
 * weiterleitet.
 * 
 * @version 3.1 vom 4.11.2015
 * @author Klaus Bovermann
 */
public class GraphClient extends Client {

	private AusgabeFrame meinLauscher;

	public GraphClient(String pIPAdresse, int pPortNr, AusgabeFrame derLauscher) {
		super(pIPAdresse, pPortNr);
		this.meinLauscher = derLauscher;
	}

	public void processMessage(String pMessage) {
		String[] tags = pMessage.split(PROTOKOLL.TRENNER);
		ausgabe(pMessage);	
		if (tags[0].equals(PROTOKOLL.SC_GEWINN_ENDE)) {
			this.close();
		}
	}

	/**
	 * der uebergebene Text wird an den Ausgabeframe weitergeleitet
	 * 
	 * @param pText Der Text, den der Client vom Server erhalten hat.
	 */
	public void ausgabe(String pText) {
		if (this.meinLauscher != null) {
			this.meinLauscher.ausgeben(pText);
		}

	}
}
