package GCG.oldClient;

import javax.swing.*;

import java.awt.BorderLayout;

/**
 * 
 * @version 3.1 vom 4.11.2015
 * @author Klaus Bovermann
 *
 */
@SuppressWarnings("serial")
public class GraphDisplay extends JDialog {
	private GraphPane centerPane;
	private AusgabeFrame meineAusgabe;

	public GraphDisplay(AusgabeFrame dieAusgabe) {
		// JDialog(Dialog owner, String title, boolean modal)
		super(dieAusgabe, "Der Graph", false);// NON modal!
		this.meineAusgabe = dieAusgabe;
		this.setLayout(new BorderLayout());
		
		this.centerPane = new GraphPane(this);
		
		this.add("Center", this.centerPane);
		this.setSize(640, 400);
		}

	public void send (String nachricht) {
		this.meineAusgabe.send(nachricht);
	}
	
	/**
	 * Der Graph wird graphisch dargestellt. Ggf. wird vorher dieses Fenster
	 * sichtbar gemacht.
	 * 
	 * @param graph
	 *            Die textuelle Darstellung des Graphen, auf dem gespielt wird.
	 */
	public void anzeigen(String graph) {
		if (!this.isVisible()) {
			this.setVisible(true);
		}
		centerPane.GraphAnzeigen(graph);
	}

	/**
	 * Die neue Farbinformation wird graphisch dargestellt.
	 * 
	 * @param knotenName
	 *            Der Name des zu faerbenden Knotens
	 * @param farbName
	 *            Die Nummer der Farbe, mit dem der Knoten gefaerbt werden soll
	 */
	public void updateColor(String knotenName, String farbName) {
		centerPane.updateColor(knotenName, farbName);
	}

	public void farbzahlNeu(String anzahlFarbenText) {
		int anzahlFarben = 4;
		try {
			anzahlFarben = Integer.parseInt(anzahlFarbenText);
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		centerPane.setAnzahlFarben(anzahlFarben);
	}
}
