package GCG.oldClient;

import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Panel;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JButton;
import javax.swing.JTextField;

/**
 * Ein Frame, der mit Hilfe des RechenClients Strings an den Server sendet.
 * 
 * @version 3.1 vom 4.11.2015
 * @author Klaus Bovermann
 */
@SuppressWarnings("serial")
public class SenderFrame extends Frame {
	private JTextField Eingabe;
	private JButton schicken;
	private JButton btnStarten;

	private GraphClient meinClient;
	private JTextField serverportEingabe;
	private JTextField serverIPEingabe;
	private AusgabeFrame derLauscher;

	// Ende Attribute

	public SenderFrame(String title, AusgabeFrame derLauscher) {
		super(title);

		this.derLauscher = derLauscher;

		// Frame-Initialisierung
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent evt) {
				dispose();
			}
		});
		int frameWidth = 400;
		int frameHeight = 200;
		setSize(frameWidth, frameHeight);
		Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
		int x = (d.width - getSize().width) / 2;
		int y = (d.height - getSize().height) / 2;
		setLocation(x, y);
		Panel cp = new Panel(null);
		add(cp);

		Eingabe = new JTextField();
		Eingabe.setBounds(8, 76, 130, 24);
		Eingabe.setText("");
		cp.add(Eingabe);

		schicken = new JButton();
		schicken.setBounds(150, 77, 117, 25);
		schicken.setText("Abschicken!");
		schicken.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				schicken_ActionPerformed(evt);
			}
		});
		this.schicken.setEnabled(false);
		cp.add(schicken);

		btnStarten = new JButton("Starten");
		btnStarten.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				verbinden();
			}
		});
		btnStarten.setBounds(150, 16, 117, 29);
		this.btnStarten.setEnabled(true);
		cp.add(btnStarten);

		serverportEingabe = new JTextField();
		serverportEingabe.setText("55555");
		serverportEingabe.setBounds(8, 33, 130, 26);
		cp.add(serverportEingabe);
		serverportEingabe.setColumns(10);

		serverIPEingabe = new JTextField();
		serverIPEingabe.setText("localhost");
		serverIPEingabe.setBounds(8, 6, 130, 26);
		cp.add(serverIPEingabe);
		serverIPEingabe.setColumns(10);
		// Ende Komponenten

		setResizable(false);
		setVisible(true);
	}

	private void verbinden() {
		if (this.btnStarten.isEnabled()) {
			String serverIP = this.serverIPEingabe.getText();
			int serverPort = Integer.parseInt(this.serverportEingabe.getText());
			this.meinClient = new GraphClient(serverIP, serverPort, derLauscher);
			this.derLauscher.setDerGraphClient(meinClient);
			this.btnStarten.setEnabled(false);
			this.schicken.setEnabled(true);
		}
	}

	private void schicken_ActionPerformed(ActionEvent evt) {
		if (this.schicken.isEnabled()) {
			String s = this.Eingabe.getText();
			this.meinClient.send(s);
		}
	}
}
